#!/bin/sh

ksmroot=${ksmroot:-"/mnt/onboard/.adds/kbmenu"}
infile=$ksmroot/usersettings.txt
outfile=$ksmroot/ksm_ini

if [ ! -f $infile ]; then
  exit
fi

if [ -f $outfile ]; then
  exit
fi


secGeneral=
secGeometry=
secKoreader=
secNickel=
secSpecial=

#lines=$(<$infile)
lines=$( cat $infile)

# remove utf8 bom
lines=$(echo "$lines" | awk 'NR==1{sub(/^\xef\xbb\xbf/,"")}1')
# remove CR
lines=$(echo "$lines" | awk '{gsub(/\r/, ""); print $0}')

IFS=$'\n'
for line in $lines
do
  line="${line#"${line%%[![:space:]]*}"}"
  case "$line" in
    useMultiplefonts=*|frontlightOnLevel=*|kobomenuFontsize=*|kobomenuMenuBarFontsize=*|enablerotation=*|ksmImageWidthLandscape=*|ksmImageWidthPortrait=*|preventfreeze=*|useDropbear*|ksmAutoselectafter=*|ksmAutoselectoption=*|dontTamperwithFrontlight=*|duringPWcheckActivate=* )
      secGeneral="$secGeneral\n$line"
      ;;
    deleteSDRsOnboard=*|combineKoreaderAdditions=*|selectKoreaderVersion=*|insertKoreaderNickelSwitch*|insertNickelKoreaderSwitch=* )
      secKoreader="$secKoreader\n$line"
      ;;
    nickelpreload=*|avoidPickel=* )
      secNickel="$secNickel\n$line"
      ;;
    KSMdebugmode=*|export* )
      secSpecial="$secSpecial\n$line"
      ;;
    ksmGeometryValuesN=*|ksmGeometryValuesS=*|ksmGeometryValuesE=*|ksmGeometryValuesW=* )
      secGeometry="$secGeometry\n$line"
      ;;
  esac
done

secGeneral=$(echo -e "$secGeneral" | sort)
secGeometry=$(echo -e "$secGeometryl" | sort)
secKoreader=$(echo -e "$secKoreader" | sort)
secNickel=$(echo -e "$secNickel" | sort)
secSpecial=$(echo -e "$secSpecial" | sort)

echo -e "[general]$secGeneral\n\n[geometry]$secGeometry\n\n[koreader]$secKoreader\n\n[nickel]$secNickel\n\n[special]$secSpecial\n" > $outfile
